//------------------------------------------------------
// module  : FunctionrSeg.h
// auteur  : Mignotte Max
// date    :
// version : 1.0
// langage : C++
// labo    : DIRO
// note    :
//------------------------------------------------------
// quelques fonctions  

//------------------------------------------------
// FICHIERS INCLUS -------------------------------
//------------------------------------------------
#include <stdio.h>
#include <math.h>
#include <stdlib.h>
#include <string.h>
#include <iostream>
#include <new>
#include <time.h>

#include "Region.h"

//------------------------------------------------
// CONSTANTES & DEFINITIONS ----------------------
//------------------------------------------------
#define PI  3.14159
#define GREY_LEVEL 255
#define BIGNUMBER 100000000
#define TROIS 3

#define CARRE(X) ((X)*(X))
#define MAX(a,b)   (((a)>(b))?(a):(b))
#define MIN(a,b)   (((a)>(b))?(b):(a))


//------------------------------------------------
// PROTOTYPE -------------------------------------
//------------------------------------------------

//>Matrix Allocation
float*    fmatrix_allocate_1d(int);
float**   fmatrix_allocate_2d(int,int);
float***  fmatrix_allocate_3d(int,int,int);
float**** fmatrix_allocate_4d(int,int,int,int);
int*      imatrix_allocate_1d(int);
int**     imatrix_allocate_2d(int,int);
int***    imatrix_allocate_3d(int,int,int);
int****   imatrix_allocate_4d(int,int,int,int);

void  free_fmatrix_1d(float*);
void  free_fmatrix_2d(float**);
void  free_fmatrix_3d(float***,int);
void  free_fmatrix_4d(float****,int,int);
void  free_imatrix_1d(int*);
void  free_imatrix_2d(int**);
void  free_imatrix_3d(int***,int);
void  free_imatrix_4d(int****,int,int);

//>Matrix Gestion 
void  copy_mat(float**,float**,int,int);
void  copy_mat(float***,int***,int,int,int);
void  copy_mat(int***,int***,int,int,int);
void  Recal(float**,int,int);

//>Random
float randomize(void);
float randomize2(void);
float random_flo(float);

//>Load/Save File
void GetLengthWidth(char*,int*,int*);
void load_image_ppm(char*,int***,int,int);
void SaveImagePgm(char*,char*,float**,int,int);
void SaveImagePpm(char*,char*,int***,int,int);

 //>Space Color
void RGBToHSV(float,float,float,float*,float*,float*);
void RGBToYIQ(float,float,float,float*,float*,float*);
void RGBToXYZ(float,float,float,float*,float*,float*);
void XYZToRGB(float,float,float,float*,float*,float*);
void RGBToLAB(float,float,float,float*,float*,float*);
void RGBToLUV(float,float,float,float*,float*,float*);
void RGBToI1I2I3(float,float,float,float*,float*,float*);
void RGBToH1H2H3(float,float,float,float*,float*,float*);
void RGBToHSL(float,float,float,float*,float*,float*);
void RGBToTSL(float,float,float,float*,float*,float*);
void RGBToYCbCr(float,float,float,float*,float*,float*);
void RGBToP1P2(float,float,float,float*,float*,float*);
void ColorBase(int***,int***,int,int,int);

//>Kmean
int Identical(int*,int**,int,int);
void KmeanFast(int**,int,int,int,int*,int,int);
void KmeanFast(int**,int,int,int,int*,int,int,float**,int,int,float);

//>Detexturing
void ComputeMatSegMoy(float***,int***,SetRegion**,int,int,int);

//>Spatial Constraints 
void ComputeContour(float**,float**,int,int);    //???
void GradMCS2(int***,float**,int,int,int,int,int);
void Paint(float**,int**,int,int,int,int,int);
void Paint(float**,float**,int,int,int,int,int);
void ConvertCertainClassRegionInf(float**,int,int);
void ContrainWithSeg(float**,int,int,float**);

//>Nettoyage
int FuseSmallRegions(float**,int,int,int*,int,float);
void MedianFilter(float**,int,int,int);
void swap(float*,float*);
void sort(float*,int,int);

//>Class>Regions
void ConvertClassRegion(float**,int,int);

//>Visu
void AddContourImg(float**,int***,int,int,int);

//>Essai
int FuseSmallRegions2(float**,int,int,int*,int,float);
