//---------------------------------------------------
// module  : KmeanConstrain.h                         
// auteur  : Max Mignotte                            
// date    :                                              
// langage : C++                                      
// labo    :                                  
//---------------------------------------------------

#ifndef KMEANCONSTRAIN_H
#define KMEANCONSTRAIN_H

//------------------------------------------------
// FICHIERS INCLUS -------------------------------
//------------------------------------------------
#include "FunctionSeg.h"
#include "Region.h"

//------------------------------------------------
// DEFINITIONS -----------------------------------
//------------------------------------------------
#define NB_ESPACE_COUL 10
#define NCHAR 200
#define TROIS 3

//------------------------------------------------
// CLASSE KMEANCONSTRAIN -------------------------
//------------------------------------------------
class KmeanConstrain
{
  //--Donnees--
  //-----------
  public:

  //Matrices Img
  int***    mat_img;
  float**   mat_seg;

  int***    mat_imgout;
  float***  mat_imgouf;

  float***  smat_seg;
  float***  tmat_seg;

  float**  mat1;

  //ParamIMG
  int width,length;

  //Parametre.
  int   NbCl;
  int   Size;
  float Regul;

  int   Seed;
  
  //ParametreSeg
  int   NbRegions;
 
  //Flag
  int  flag_save;

  //Utile
  char Name_Sauve[NCHAR];
  char Name_Img[NCHAR];
  char Extension[NCHAR];  

  //--Methodes--
  //------------
  public:
  KmeanConstrain(int***,int,int);
  ~KmeanConstrain();

  //Function
  void Segmente();

  //-------------------------------------------------
  //Algorithm
  //-------------------------------------------------
  //Segmentation <Histo><COLOR-BASE>
  void  SegmentationHistoCOLORKmeanFast(int***,float**,int,int,int,int,int,int,int);
  void  SegmentationMCOLORKmeanFast(int***,float**,int,int,int,int,int,int,float**,float);
};

#endif 
