//---------------------------------------------------
// module  : Region.h                         
// auteur  : Max Mignotte                            
// date    :                                              
// langage : C++                                      
// labo    :                                 
//---------------------------------------------------
// 

#ifndef REGION_H
#define REGION_H

//-----------------------------------------------
// FICHIERS INCLUS ------------------------------
//-----------------------------------------------
#include <stdio.h>


//------------------------------------------------
// DEFINITIONS -----------------------------------
//------------------------------------------------
#define DEUX   2
#define TROIS  3
#define VERY_BIG_NUMBER 1000000

//------------------------------------------------
//  STRUCTURE ------------------------------------
//------------------------------------------------
typedef struct region
    { 
     int** pixs;

     int nb_points;

     int row_min,col_min;
     int row_max,col_max;

     int CoulR,CoulV,CoulB;
    } region; 

//------------------------------------------------
// CLASSE REGIONS  -------------------------------
//------------------------------------------------
class SetRegion  
{
  //-- Donnees --
  //-------------
  public:
  //Matrices
   int**  mat;
   int**  mat_tmp;
   int**  mat_belonging;
   int*** mat_coul; 

   int width,length;
   region** pp_region;

   //Stat
   int   nbmax_regions;
   int   nb_regions; 
   int   size_max;
   float size_min_obj; 
   float size_max_obj;
   float size_moy_obj;
   float nb_regions_1pix; 

   //flag
   int flag_ssilent;

 protected:
   int compteur_pixels;   
     
  //-- Methodes --
  //--------------
  public:
    SetRegion(int**,int,int,int);
    SetRegion(float**,int,int,int);
    ~SetRegion();

    void find_regions();

    //-Utile ---------
    void find_objet1(int,int,int,int);
    void find_objet2(int,int,int,int);
    void find_objet3(int,int,int,int);
    void find_objet4(int,int,int,int);
    void find_objetRandom(int,int,int,int);
    void find_obj1(int,int,int,int);
    void find_obj2(int,int,int,int);
    void find_obj3(int,int,int,int);
    void find_obj4(int,int,int,int); 
   
    //-Visu & Stat--------
    void stat_regions();
    void fill_mat_color();
    void fill_mat_regions(float**); 
};

#endif 
